-- programma per il controllo di un robot collegato in rete con ESP8266
-- Il modulo ESP8266 è connesso come Acces Point quindi è possibile un collegamento
-- punto-punto inviando il TCP del modulo oppure wia WIFI con il TCP assegnato dal WITI
-- Le connessioni sono;
-- PIN D3 D4  D1(PWM)motore  di destra
-- PIN D5 D6  D2 (PWM)motore di sinistra
-- D1 D2 uscita PWM di SPEED

wifi.setmode(wifi.STATION)
wifi.sta.config("belkin.44e4","24f646d9")
print(wifi.sta.getip())
wifi.setmode(wifi.STATIONAP);
wifi.ap.config({ssid="Test",pwd="12345678"});

--Configurazione i/o
gpio.mode(1, gpio.OUTPUT);
gpio.write(1, gpio.LOW);
gpio.mode(2, gpio.OUTPUT);
gpio.write(2, gpio.LOW);
gpio.mode(3, gpio.OUTPUT);      -- D3 in uscita
gpio.write(3, gpio.LOW);        -- preset a zero
gpio.mode(4, gpio.OUTPUT);
gpio.write(4, gpio.LOW);
gpio.mode(5, gpio.OUTPUT);
gpio.write(5, gpio.LOW);
gpio.mode(6, gpio.OUTPUT);
gpio.write(6, gpio.LOW);

--Configurazione e avvio PWM
pwm.setup(1,1000,1023);     -- PIN1
pwm.start(1); 
pwm.setduty(1,0);
pwm.setup(2,1000,1023);     --PIN2
pwm.start(2); 
pwm.setduty(2,0);

spdTargetA = 1023;		--velocità max
spdCurrentA = 0;		--velocità attuale
spdTargetB = 1023;      --velocità max
spdCurrentB = 0;        --velocità attuale
stopFlag=true;

--speed control procedure
tmr.alarm(1, 200, 1, function()
    if stopFlag==false then
        spdCurrentA=spdTargetA;
        spdCurrentB=spdTargetB;
        pwm.setduty(1,spdCurrentA);
        pwm.setduty(2,spdCurrentB);
    else
        pwm.setduty(1,0);
        pwm.setduty(2,0);
    end
end)


srv=net.createServer(net.TCP)
srv:listen(80,function(conn)
    conn:on("receive", function(client,request)
        local buf = "";
        local _, _, method, path, vars = string.find(request, "([A-Z]+) (.+)?(.+) HTTP");
        if(method == nil)then
            _, _, method, path = string.find(request, "([A-Z]+) (.+) HTTP");
        end
        local _GET = {}
        if (vars ~= nil)then
            for k, v in string.gmatch(vars, "(%w+)=(%w+)&*") do
                _GET[k] = v
            end
        end
        buf = buf.."<h1> ESP8266 Car Control<h1>";     --Intestazione		
        buf = buf.."<a href=\"/?pin=ON1\"> <button style=\"background-color: #008000;width:200px;height:70px\"> <font size=\"6\">AVANTI </font> </button> </a>";
        buf = buf.."<a href=\"/?pin=ON2\"> <button style=\"background-color: #cc8000;width:200px;width:200px;height:70px\"> <font size=\"6\">INDIETRO </font> </button> </a> <br/><br/>";
        buf = buf.."<a href=\"/?pin=ON5\"> <button style=\"background-color: #cc0000;width:200px;height:70px\"> <font size=\"6\">FERMA </font> </button> </a> <br/><br/>"; 
        buf = buf.."<a href=\"/?pin=ON3\"> <button style=\"background-color: #6699ff;width:200px;height:70px\"> <font size=\"6\">SINISTRA</font> </button> </a>";
        buf = buf.."<a href=\"/?pin=OFF3\"> <button style=\"background-color: #6699ff;width:200px;height:70px\"> <font size=\"6\">DESTRA</font> </button> </a> <br/><br/>"; 
        buf = buf.."<a href=\"/?pin=ON4\"> <button style=\"background-color: #cccc00;width:200px;height:70px\"> <font size=\"6\">SPEED-D ++ </font> </button> </a>";
        buf = buf.."<a href=\"/?pin=OFF4\"> <button style=\"background-color: #cccc00;width:200px;height:70px\"> <font size=\"6\">SPEED-D -- </font> </button> </a> <br/><br/>";  
        buf = buf.."<a href=\"/?pin=ON6\"> <button style=\"background-color: #cccc00;width:200px;height:70px\"> <font size=\"6\">SPEED-S ++ </font> </button> </a>";
        buf = buf.."<a href=\"/?pin=OFF6\"> <button style=\"background-color: #cccc00;width:200px;height:70px\"> <font size=\"6\">SPEED-S -- </font> </button> </a> <br/><br/>";

		local _on,_off = "",""
        -- AVANTI
		if(_GET.pin == "ON1")then
              gpio.write(3, gpio.HIGH);
			  gpio.write(4, gpio.LOW);
			  gpio.write(5, gpio.HIGH);
			  gpio.write(6, gpio.LOW);
              stopFlag = false;

        -- INDIETRO
		elseif(_GET.pin == "ON2")then
              gpio.write(3, gpio.LOW);
			  gpio.write(4, gpio.HIGH);      			  
			  gpio.write(5, gpio.LOW);
			  gpio.write(6, gpio.HIGH);
			  stopFlag = false;
		
	    -- GIRA
		elseif(_GET.pin == "ON3")then		-- DESTRA   
              gpio.write(3, gpio.HIGH);
			  gpio.write(4, gpio.LOW);
			  gpio.write(5, gpio.LOW);
			  gpio.write(6, gpio.HIGH);
			  stopFlag = false;

        elseif(_GET.pin == "OFF3")then		-- SINISTRA           
			  gpio.write(3, gpio.LOW);
			  gpio.write(4, gpio.HIGH);
			  gpio.write(5, gpio.HIGH);
			  gpio.write(6, gpio.LOW);
			  stopFlag = false;
			  
		-- STOP
		elseif(_GET.pin == "ON5")then
			  gpio.write(3, gpio.LOW);
			  gpio.write(4, gpio.LOW);
			  gpio.write(5, gpio.LOW);
			  gpio.write(6, gpio.LOW);
              stopFlag = true;
		
		-- PWM PIN1 motore di destra
		elseif(_GET.pin == "ON4")then
              spdTargetA = spdTargetA+50;
              if(spdTargetA > 1023) then 
              spdTargetA = 1023;
              end
        elseif(_GET.pin == "OFF4")then
              spdTargetA = spdTargetA-50;
              if(spdTargetA < 0) then 
              spdTargetA = 0;
              end  
        
		-- PWM PIN2 motore di sinistra
		elseif(_GET.pin == "ON6")then
              spdTargetB = spdTargetB+50;
              if(spdTargetB > 1023) then 
              spdTargetA = 1023;
              end
        elseif(_GET.pin == "OFF6")then
              spdTargetB = spdTargetB-50;
              if(spdTargetB  < 0) then 
              spdTargetB = 0;
              end  
			  
		end  -- _GET-PIN
        client:send(buf);
        client:close();
        collectgarbage();
    end)
end)
